--- res_monitor.c.orig	2005-02-10 19:22:34.000000000 +0100
+++ res_monitor.c	2005-02-11 00:03:33.578948829 +0100
@@ -44,7 +44,11 @@
 "          and a target mixed file name which is the same as the leg file names\n"
 "          only without the in/out designator.\n"
 "          If MONITOR_EXEC_ARGS is set, the contents will be passed on as\n"
-"          additional arguements to MONITOR_EXEC\n"
+"          additional arguements to MONITOR_EXEC at the end of the command\n"
+"          line.\n"
+"          If MONITOR_EXEC_GENARGS is set the contents will be passed on as\n"
+"          additional arguements to MONITOR_EXEC just after the MONITOR_EXEC\n"
+"          command and before the soundfiles.\n"
 "          Both MONITOR_EXEC and the Mix flag can be set from the\n"
 "          administrator interface\n"
 "\n"
@@ -188,7 +192,7 @@
 /* Stop monitoring a channel */
 int ast_monitor_stop(struct ast_channel *chan, int need_lock)
 {
-	char *execute, *execute_args;
+	char *execute, *execute_args, *execute_genargs;
 	int delfiles = 0;
 
 	if (need_lock) {
@@ -248,8 +252,12 @@
 			if (!execute_args || ast_strlen_zero(execute_args)) {
 				execute_args = "";
 			}
+			execute_genargs = pbx_builtin_getvar_helper(chan, "MONITOR_EXEC_GENARGS");
+                        if (!execute_genargs || ast_strlen_zero(execute_genargs)) {
+                                execute_genargs = "";
+                        }
 			
-			snprintf(tmp, sizeof(tmp), "%s \"%s/%s-in.%s\" \"%s/%s-out.%s\" \"%s/%s.%s\" %s &", execute, dir, name, format, dir, name, format, dir, name, format,execute_args);
+			snprintf(tmp, sizeof(tmp), "%s %s \"%s/%s-in.%s\" \"%s/%s-out.%s\" \"%s/%s.%s\" %s &", execute, execute_genargs, dir, name, format, dir, name, format, dir, name, format,execute_args);
 			if (delfiles) {
 				snprintf(tmp2,sizeof(tmp2), "( %s& rm -f \"%s/%s-\"* ) &",tmp, dir ,name); /* remove legs when done mixing */
 				strncpy(tmp, tmp2, sizeof(tmp) - 1);
